This project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

# Changelog for gCube Catalogue (gCat) Service

## [v2.0.0-SNAPSHOT]

- Improved check on controlled vocabulary to match corner cases [#20742]
- Added PATCH method on Item collection [#19768]
- Switched JSON management to gcube-jackson [#19735]
- Added support to publish an item organizations not matching the current context [#19365]

## [v1.4.5] 

- Removed 'owner_org' field from result when reading an item [#20919]
- Dirty patched item validator [#20965]
- Improved error message return with message got from CKAN [#19516]


## [v1.4.4] 

- Added count method for Item collection [#20627]
- Added count method for Organization, Group and Profile collection [#20629]
- Switched JSON management to gcube-jackson [#19735]


## [v1.4.3] [r4.23.0] - 2020-06-19

- Social Post is disabled if not explicitly enabled by the client [#19295] 
- Solved null pointer exception while creating the JSON object to send to CKAN to create the user [#19395]


## [v1.4.2] [r4.20.0] - 2020-02-14

- Added method to retrieve a persisted file
- Considering that a file could not be persisted because it could be published via portlet


## [v1.4.1] [r4.18.0] - 2019-12-20

- Fixed distro files and pom according to new release procedure
- Fixed metadata checks


## [v1.4.0] [r4.15.0] - 2019-11-06

- Items listing API when invoked at VO level allow to get all the catalogue items or filtering them by organization  [#17635]
- Enabled the possibility of filtering the result of items listing API [#17645]
- User information are checked/updated on CKAN using portal information [#16360]


## [v1.3.0] [r4.14.0] - 2019-06-12

- Removed the requirement of providing the id of an item in update [#16740]
- Resource URL existence is not checked anymore [#16748]


## [v1.2.0] 

- Separated REST class for Profile management from the logic which effectively manage profile on IS
- Tags are now properly created/added according to profile definition [#16182]
- Groups are now properly created/added according to profile definition [#16183]
- Setting format in resources [#16347]
- Validated provided LicenseId for Item [#16354]
- Capacity field is removed from the provided item content if any [#16410]
- Fixed bug on getting responses from social service [#16330]
- Added the possibility to disable social post on item creation [#13335]
- Fixed bug on social post creation [#16322]
- Improved social post message [#16322] 
- Added support to publish in specific organizations when the request is not performed at VRE level [#16635]


## [v1.1.0] [r4.13.1] - 2019-02-26

- Added Item URL via URI Resolver in extras field [#13309]
- The final URL is retrieved only URI resolver pointing to Storage Hub [#13303]
- Enforced items to be searchable in 'extras' field [#13306]
- Switched item listing to use package_search in place of package_list [#13307]
- Refactored to use storage-hub-persistence library [#13076] 
- Added Create/Update/Delete in Profile Collection [#13079] 
- Fixed issues in Resource collection
- Refactored to use gcat-api library


## [v1.0.0] 

- First Release

